var selectedDn=config.dnbase;
var search="";
var scope="one";
	
function setInitValues() {
	document.getElementById("serverName").innerHTML=config.servername;
	setDefaultLangHeaders();
	selectDN(selectedDn);
}

function selectDN(dn) {
	selectedDn=dn;
	
	updateNavigation();
	updateEntryInfo();
	updateChildsInfo();
}

function updateNavigation() {
	var res="<ul>";

	var buildDn="";
	var rdns=selectedDn.split(",");
	for (var i=(rdns.length-1); i>=0; i--) {
		if (buildDn!="")
			buildDn=","+buildDn;
		buildDn=rdns[i]+buildDn;
		if (buildDn.indexOf(config.dnbase)>=0) {
			res = res + "<li><a href='javascript:selectDN(\""+buildDn+"\");'>"+rdns[i]+"</a></li>";
		}
		else {
			res = res + "<li>"+rdns[i]+"</li>";
		}
	}
	res = res + "</ul>";

	var res2="";
	for (var i=0 ; i<config.i18n.length;i++) {
		if (config.sel_i18n==config.i18n[i]) {
			res2 = res2 + "<span>"+config.i18n[i]+"</span>";
		}
		else {
			res2 = res2 + "<span><a href='javascript:setLang(\""+config.i18n[i]+"\");'>"+config.i18n[i]+"</a></span>";
		}
		if (i<(config.i18n.length-1)) {
			res2 = res2 + "&nbsp;<span class='horSep'>|</span>&nbsp;";
		}
	}
    
	document.getElementById("langContent").innerHTML=res2;

	var contentPanel=document.getElementById("textContent");
	contentPanel.innerHTML=res;

    document.getElementById("textSearch").value=search;
}

function updateEntryInfo() {
	var headerPanel=document.getElementById("selectedDn");
	headerPanel.innerHTML=selectedDn;
	
	loadEntryInfo();
}

function getLoadingPanel() {
	var res="<div>Cargando...</div>";
	
	return res;
}

function setLang(num){
     config.language = config.i18n[num];
     config.sel_i18n=num;
     setDefaultLangHeaders();
     setInitValues()
}

function setDefaultLangHeaders(){
     document.getElementById("navigation").innerHTML=getI18N("navigation");
     document.getElementById("connLdap").innerHTML=getI18N("connLdap");
     document.getElementById("titleNavega").innerHTML=getI18N("titleNavega");
     document.getElementById("contInfo").innerHTML=getI18N("contInfo");
     document.getElementById("searchLabel").innerHTML=getI18N("searchLabel");
     document.getElementById("firstLevel").innerHTML=getI18N("firstLevel");
     document.getElementById("recursive").innerHTML=getI18N("recursive");
     document.getElementById("buttonSearch").value=getI18N("searchLabel");
}

function loadEntryInfo() {
    document.getElementById("entryContent").innerHTML=getLoadingPanel();
	var url=config.baseWS+"getEntry.php?dn="+encode64(selectedDn);
	if (typeof config.language!='undefined') {
		url=url+"&lang="+config.language;
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
	    	var res="";
            var xml=request.responseXML;
            var attributes=xml.getElementsByTagName("Attribute");
            var first=0;
            for (var i=0; i<attributes.length; i++) {
            	var name=attributes[i].getAttribute("name");
            	var parsedName=name;
            	if (name.indexOf(";")>=0) {
            		parsedName=name.substr(0,name.indexOf(";"));
            	}
            	if (isVisibleAttribute(name)) {
            		if (first==0) {
            			res=res+"<div class='firstEntryAttribute'>";
            		}
            		else {
            			res=res+"<div class='entryAttribute'>";
            		}
           			first=first+1;
	            	res=res+"	<div class='nameAttr'>"+getI18N(name)+"</div>";
	            	if (first%2==0) {
    	        		res=res+"	<div class='valueAttr'>"
    	        	}
    	        	else {
    	        		res=res+"	<div class='valueAttrTwo'>"
    	        	}
       	    		var values=attributes[i].getElementsByTagName("AttributeValue");
            		for (var j=0; j<values.length; j++) {
            			res=res+"	<div class='itemValueAttr'>";
            			if (values[j].hasAttribute("lang")) {
            				res=res+"<span class='itemValueAttrLang'>["+values[j].getAttribute("lang")+"]</span>&nbsp;";
            			}
            			var val=values[j].getAttribute("value");
            			if (viewAttribute[parsedName]) {
    		        		res=res+(viewAttribute[parsedName](name,val));
    		        	}
    	    	    	else {
	            			res=res+(values[j].getAttribute("value"));
		            	}
		            	res=res+"</div>";
	            	}
    	        	res=res+"	</div>";
					res=res+"</div>";
				}
            }
            document.getElementById("entryContent").innerHTML=res;
        }
    }
    request.send(null);
 }
 
 function isVisibleAttribute(name) {
 	var res=false;
 	for (var i=0; i<visibleAttributes.length&&res==false; i++) {
 		res=(visibleAttributes[i]==name);
 	}
 	return res;
 }
 
function updateChildsInfo() {
    document.getElementById("childContent").innerHTML=getLoadingPanel();
	var url=config.baseWS+"searchLDAP.php?dnbase="+encode64(selectedDn)+"&scope="+scope+"&selAttr="+encode64(config.defaultSearchedAttrs.join(","));
	if (search!="") {
		var variable=config.searchPattern[0];
		var dataSearch=config.searchPattern[1].replace(new RegExp(variable, "gi"),search);
		alert(dataSearch);
		url=url+"&filter="+encode64(dataSearch);
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
	    	scope="one";
	    	search="";
	    	var res="";
            var xml=request.responseXML;
            var entries=xml.getElementsByTagName("Entry");
            if (entries.length==0) {
			    document.getElementById("childBox").style.visibility="hidden";
            }
            else {
			    document.getElementById("childBox").style.visibility="visible";
	            for (var i=0; i<entries.length; i++) {
            		var dnEntry=entries[i].getAttribute("dn");
            		var outputEntry=dnEntry;
        	    	var found=false;
    	        	var attrs=entries[i].getElementsByTagName("Attribute");
	            	for (var j=0; j<attrs.length&&found==false; j++) {
            			var nameAttr=attrs[j].getAttribute("name");
            			for (var k=0; k<config.defaultSearchedAttrs.length&&found==false; k++) {
        	    			if (config.defaultSearchedAttrs[k]==nameAttr) {
    	        				found=true;
	            				var values=attrs[j].getElementsByTagName("AttributeValue");
            					outputEntry=values[0].getAttribute("value");
            				}
            			}
            		}
            		res=res+"<div class='childItem'>";
        	    	res=res+getI18N(nameAttr)+":&nbsp;"+"<a href='javascript:selectDN(\""+dnEntry+"\");'>"+outputEntry+"</a>";
    	        	res=res+"</div>";
	            }
            }
		    document.getElementById("childContent").innerHTML=res;
        }
    }
    request.send(null);
}

function doSearch(f) {
	for (var i=0; i<f.elements["scope"].length; i++) {
		var radio = f.elements["scope"][i];
		if (radio.checked) {
			scope=radio.value;
		}
	}
	search=f.elements["textSearch"].value;
	updateChildsInfo();
	
	return false;
}

function getI18N(name) {
	var res=name;
	if (!(i18n[name]==undefined)&&!(i18n[name][config.sel_i18n]==undefined)) {
		res=i18n[name][config.sel_i18n];
	}
	return res;
}